#include <FreeRTOS.h>
#include <queue.h>

#include "lib/mini-printf.h"

#include "serial_utils.h"

char vq_printf(QueueHandle_t queue, int buflen, char *fmt, va_list argp) {
    char *buf = (void *)pvPortMalloc(buflen);
    if(buf == NULL) {
        return 0;
    }
    vsnprintf(buf, buflen, fmt,  argp);
    if (xQueueSend(queue, (void *)&buf, 0) != pdTRUE) {
        vPortFree(buf);
        return 0;
    }
    return 1;
}

char q_printf(QueueHandle_t queue, int buflen, char *fmt, ...) {
    va_list argp;
    va_start(argp, fmt);
    char res = vq_printf(queue, buflen, fmt, argp);
    va_end(argp);
    return res;
}
